   package com.ccwangluo.im;

import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import com.ccwangluo.ccim.CCIMClient;
import com.ccwangluo.ccim.listener.ResultCallback;
import com.ccwangluo.ccim.listener.ResultEventCallback;
import com.ccwangluo.im.databinding.FragmentFirstBinding;

import java.util.ArrayList;
import java.util.List;

import ccim.protocol.Chat;
import ccim.protocol.Message;

public class FirstFragment extends Fragment {

    private FragmentFirstBinding binding;
    private static final String TAG = FirstFragment.class.getName();

    @Override
    public View onCreateView(
            LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState
    ) {

        binding = FragmentFirstBinding.inflate(inflater, container, false);
        return binding.getRoot();
    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        CCIMClient.getInstance().initSDK();
        CCIMClient.getInstance().registerMessageListener(new ResultEventCallback<Chat.ChatResponseMessage>() {
            @Override
            public void onSuccess(Chat.ChatResponseMessage chatResponseMessage) {
                new Handler(Looper.getMainLooper()).post(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(getContext(),chatResponseMessage.toString(),Toast.LENGTH_SHORT).show();
                    }
                });

            }
        });

        binding.buttonLogin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().login("user1","123456",1L,new ResultCallback(){

                    @Override
                    public void onSuccess() {

                    }

//                    @Override
//                    public void onFailed(int errorCode) {
//
//                    }
                });
            }
        });

        binding.getChatList.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().getChatList(new ResultEventCallback<Chat.PullContactsResponse>() {
                    @Override
                    public void onSuccess(Chat.PullContactsResponse pullContactsResponse) {
                        List<Chat.PullContactsResponse.Channel> channelsList = pullContactsResponse.getChannelsList();
                        Log.d(TAG, "channelsList: " + channelsList.toString());
                        List<Chat.PullContactsResponse.ContactGroup> contactGroupsList = pullContactsResponse.getContactGroupsList();
                        Log.d(TAG, "contactGroupsList: " + contactGroupsList.toString());
                        List<Chat.PullContactsResponse.Contact> contactsList = pullContactsResponse.getContactsList();
                        Log.d(TAG, "contactsList: " + contactsList.toString());
                    }
                });
            }
        });

        binding.getOfflineMessage.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().getOfflineMessage(new ResultEventCallback<ArrayList<Message.PullOfflineMessageResponse.OfflineMessage>>() {
                    @Override
                    public void onSuccess(ArrayList<Message.PullOfflineMessageResponse.OfflineMessage> offlineMessages) {
                        Log.d(TAG, "offlineMessages: " + offlineMessages.toString());
                    }
                });
            }
        });

        binding.searchUser.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().searchUser("user2", new ResultEventCallback<List<Chat.SearchResponse.User>>() {
                    @Override
                    public void onSuccess(List<Chat.SearchResponse.User> users) {
                        Log.d(TAG, "onSuccess: " + users);
                    }
                });
            }
        });

        binding.addUser.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().addContact(Long.parseLong(binding.userId.getText().toString()), new ResultEventCallback<Chat.AddContactResponse.AddResult>() {
                    @Override
                    public void onSuccess(Chat.AddContactResponse.AddResult addResult) {

                    }
                });
            }
        });

        binding.sendTextMessage.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().sendTextMessage("你好", Long.parseLong(binding.userId.getText().toString()), new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });

        binding.getContactRequests.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().getContactRequests(new ResultEventCallback<Chat.ContactRequestsResponse>() {
                    @Override
                    public void onSuccess(Chat.ContactRequestsResponse contactRequestsResponse) {

                    }
                });
            }
        });

        binding.checkContactRequests.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().checkContactReq(Long.parseLong(binding.userId.getText().toString()), true, new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });
        binding.createContactGroupRequest.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().createContactGroup("zhangsan", new ResultEventCallback<Long>() {
                    @Override
                    public void onSuccess(Long aLong) {

                    }
                });
            }
        });

        binding.moveContactGroupRequest.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().moveContactGroup(Long.parseLong(binding.groupId.getText().toString()), Long.parseLong(binding.userId.getText().toString()), new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });

        binding.deleteContact.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().deleteContact(Long.parseLong(binding.userId.getText().toString()), new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });

        binding.blockContact.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().blockContact(Long.parseLong(binding.userId.getText().toString()), true, new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });

        binding.reportIllegalUser.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().reportIllegalUser("搞黄色", "搞黄色", Long.parseLong(binding.userId.getText().toString()), new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });

        binding.sendGroupMessage.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().sendGroupMessage("搞黄色", Long.parseLong(binding.groupId.getText().toString()), new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });

        binding.sendChannelMessage.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CCIMClient.getInstance().sendChannelMessage("搞黄色", Long.parseLong(binding.channelId.getText().toString()), new ResultCallback() {
                    @Override
                    public void onSuccess() {

                    }
                });
            }
        });


    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }

}